// **************************************************************************
// * This file is part of the FreeFileSync project. It is distributed under *
// * GNU General Public License: http://www.gnu.org/licenses/gpl.html       *
// * Copyright (C) 2008-2011 ZenJu (zhnmju123 AT gmx.de)                    *
// **************************************************************************
//
#include <iostream>
#include <wx/init.h>
#include <gtest/gtest.h>


class InitEnvironment : public testing::Environment
{
public:
    //define how to set up the environment.
    void SetUp() //virtual impl.
    {
        ASSERT_TRUE(initializer.IsOk());
    }
    //tear down the environment.
    void TearDown() {} //virtual impl.

    //wxBase libs initializer: needed for threads
    static wxInitializer initializer;
};

wxInitializer InitEnvironment::initializer;


int main(int argc, char** argv)
{
    std::cout << "Running main() from main.cpp\n";

    testing::InitGoogleTest(&argc, argv);
    testing::AddGlobalTestEnvironment(new InitEnvironment); //ownership transferred => no deletion necessary

    return RUN_ALL_TESTS();
}
